package com.isu.gaswellwatch.modbus.data.decode.impl;

import com.isu.gaswellwatch.modbus.data.ModbusMessage;
import com.isu.gaswellwatch.modbus.data.decode.DecodeHandler;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.math.NumberUtils;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * 高低位4字节解析器
 *
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/11/25 16:36
 */
@Component(HighLowBinDecodeHandler.NAME + DecodeHandler.DECODE_NAME)
public class HighLowBinDecodeHandler implements DecodeHandler {

    public static final String NAME = "highLowBin";

    @Override
    public String decode(Map<String, Object> commandPointMap, String value) {
        return StringUtils.isBlank(value) ? value : NumberUtils.createLong(value).toString();
    }

    @Override
    public void decode(Map<String, Object> commandPointMap, ModbusMessage.MessagePoint point) {
        point.setValue(this.decode(commandPointMap, point.getValue()));
    }

}
