package com.isu.gaswellwatch.utils;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/11/25 16:07
 */
public class ReverseComplementCodeUtils {

    /**
     * 原码转反码
     *
     * @param source 二进制原码
     * @return
     */
    public static String binOriginalToReverse(String source) {
        if (source.startsWith("0")) {
            return source;
        } else {
            StringBuffer sbf = new StringBuffer();
            sbf.append("1");
            String f_str = source.substring(1);
            for (int i = 0; i < f_str.length(); i++) {
                String s_str = String.valueOf(f_str.charAt(i));
                if (s_str.equals("0")) {
                    sbf.append("1");
                } else if (s_str.equals("1")) {
                    sbf.append("0");
                }
            }
            return sbf.toString();
        }
    }

    /**
     * 反码转补码, 默认补1
     *
     * @param reverse 二进制反码字符串
     * @return
     */
    public static String binReverseToComplement(String reverse) {
        return binReverseToComplement(reverse, "1");
    }

    /**
     * 反码转补码
     *
     * @param reverse    二进制反码字符串
     * @param complement 二进制补数字符串
     * @return
     */
    public static String binReverseToComplement(String reverse, String complement) {
        if (reverse.startsWith("0")) {
            return reverse;
        }
        StringBuilder sb = new StringBuilder();
        int x = 0;
        int y = 0;
        int pre = 0;//进位
        int sum = 0;//存储进位和另两个位的和
        while (reverse.length() != complement.length()) {//将两个二进制的数位数补齐,在短的前面添0
            if (reverse.length() > complement.length()) {
                complement = "0" + complement;
            } else {
                reverse = "0" + reverse;
            }
        }
        for (int i = reverse.length() - 1; i >= 0; i--) {
            x = reverse.charAt(i) - '0';
            y = complement.charAt(i) - '0';
            sum = x + y + pre;//从低位做加法
            if (sum >= 2) {
                pre = 1;//进位
                sb.append(sum - 2);
            } else {
                pre = 0;
                sb.append(sum);
            }
        }
        if (pre == 1) {
            sb.append("1");
        }
        // 翻转返回
        return sb.reverse().toString();
    }

    /**
     * 补码转十进制
     *
     * @param
     * @return
     */

    public static String binComplementToDec(String complement) {
        String h_number = complement.substring(1);
        if (complement.startsWith("0")) {
            return "" + Long.valueOf(h_number, 2);
        } else if (complement.startsWith("1")) {
            return "-" + Long.valueOf(h_number, 2);
        }
        return null;
    }
}
